package question4;

/**
 * Stack ADT.
 * @param <E> generic base type.
 */
public interface Stack<E> {

  /**
   * Size is the number of elements in stack.
   * @return the size of stack.
   */
  int size();

  /**
   * Removes the top element and returns it.
   * @return the top element.
   * @throws EmptyException if stack is empty.
   */
  E pop() throws EmptyException;

  /**
   * Adds a new element to top of stack.
   * @param value to be added to stack.
   */
  void push(E value);
}
