package question4;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.fail;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import question5.MidtermStackSln;

@SuppressWarnings("All")
public class StackTestSln {

  private Stack<Integer> stack;

  @BeforeEach
  public void setUp() throws Exception {
    stack = new MidtermStackSln<>();
  }

  @Test
  public void newStackIsEmpty() {
    assertEquals(0, stack.size());
  }

  @Test
  public void stackNotEmptyAfterPush() {
    stack.push(1);
    assertEquals(1, stack.size());
  }

  @Test
  @DisplayName("test pop throws exception if called on an empty stack")
  public void popThrowsExceptionOnEmptyStack() {
    try {
      stack.pop();
      fail("Did not throw the EmptyException");
    } catch (EmptyException ex) {
      System.out.println("pass!");
    }
  }

  @Test
  @DisplayName("test pop removes and returns the top of stack.")
  public void popRemovesAndReturnsLastPushed() {
    stack.push(1);
    stack.push(2);
    stack.push(3);
    assertEquals(3, stack.pop().intValue());
    assertEquals(2, stack.size());
    assertEquals(2, stack.pop().intValue());
    assertEquals(1, stack.size());
    assertEquals(1, stack.pop().intValue());
    assertEquals(0, stack.size());
  }
}