package question5;

import question4.EmptyException;
import question4.Stack;

/**
 * An implementation of the Stack ADT.
 *
 * @param <E> element type.
 */
public class MidtermStackSln<E> implements Stack<E> {
  private int numElements;
  private Node<E> tail;

  /**
   * Construct a MidtermStackSln.
   */
  public MidtermStackSln() {
    this.numElements = 0;
    tail = new Node<>();
  }

  @Override
  public int size() {
    return numElements;
  }

  @Override
  public E pop() throws EmptyException {
    if (size() == 0) {
      throw new EmptyException();
    }
    E value = tail.data;
    tail = tail.prev;
    numElements--;
    return value;
  }

  @Override
  public void push(E value) {
    Node<E> node = new Node<>();
    node.data = value;
    node.prev = tail;
    tail = node;
    numElements++;
  }

  private static class Node<E> {
    E data;
    Node<E> prev;
  }
}
