package question6;

import java.util.Stack;

/**
 * Solution to the Balanced Brackets challenge.
 */
@SuppressWarnings("All")
public class BalancedBracketsSln {
  /**
   * Determine if input string is a valid sequence of parentheses and brackets.
   * @param sequence a sequence of parentheses and brackets.
   * @return true is input is valid and false otherwise.
   */
  public static boolean solve(String sequence) {
    Stack<Character> stack = new Stack<>();

    for (char c: sequence.toCharArray()) {
      if (isSpace(c)) continue;
      if (isTheOpeningPair(c)) stack.push(c);
      if (isTheClosingPair(c)) {
        char last = stack.pop();
        char pair = getPair(last);
        if (c != pair) return false;
      }
    }

    return stack.size() == 0;
  }

  private static boolean isSpace(char c) {
    return c == ' ';
  }

  private static boolean isTheOpeningPair(char c) {
    return c == '(' || c == '{' || c == '[';
  }

  private static boolean isTheClosingPair(char c) {
    return c == ')' || c == '}' || c == ']';
  }

  private static char getPair(char c) {
    switch (c) {
      case '(': return ')';
      case '{': return '}';
      case '[': return ']';
      default: return ' ';
    }
  }
}
