package grade;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import question4.EmptyException;
import question4.Stack;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;
import static org.junit.jupiter.api.Assertions.fail;

public abstract class StackTest {

  protected Stack<Integer> stack;

  @BeforeEach
  public void setUp() {
    stack = createStack();
  }

  protected abstract Stack<Integer> createStack();

  @Test
  @DisplayName("[Question 5] (1) new stack is empty")
  public void newStackIsEmpty() {
    assertEquals(0, stack.size());
  }

  @Test
  @DisplayName("[Question 5] (2) pop throws exception when stack is empty")
  public void popThrowsExceptionOnEmptyStack() {
    assertThrows(EmptyException.class, () -> {
      stack.pop();
    });
  }

  @Test
  @DisplayName("[Question 5] (3) stack is not empty after a push")
  public void stackNotEmptyAfterPush() {
    stack.push(1);
    assertEquals(1, stack.size());
  }

  @Test
  @DisplayName("[Question 5] (4) pop returns the most recent pushed value")
  public void popReturnsLastPushed() {
    stack.push(1);
    stack.push(2);
    stack.push(3);
    assertEquals(3, stack.pop().intValue());
  }

  @Test
  @DisplayName("[Question 5] (5) pop removes the most recent pushed value")
  public void popRemovesLastPushed() {
    stack.push(1);
    stack.push(2);
    stack.push(3);
    stack.pop();
    assertEquals(2, stack.pop().intValue());
  }
}